#ifndef CAMERA_DRIVING_PERCEPTION_ONE_GENERAL_WRAPPER_HEADER_H
#define CAMERA_DRIVING_PERCEPTION_ONE_GENERAL_WRAPPER_HEADER_H
#include "sub/SubWrapperHelper.h"
#include "sub/SubDataWrapper.h"
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "CameraDrivingPerceptionOne_PubDataWrapper.h"
#include "CameraDrivingPerceptionOne_SubDataWrapper.h"
#include "camera_driving_perception/executable.h"

using namespace jac::ap::cameradrivingservice::proxy;
using namespace jac::ap::cameradrivingperservice::skeleton;
using namespace jac::ap::canservice::proxy;
using namespace jac::ap::slamservice::proxy;
using namespace jac::ap::vedservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(CamDrvPerception2Fusion_Provide, CamDrvPerception2Fusion_PubDataWrapper, CameraDrivingPerceptionServiceSkeleton, perception::vector_CameraPerception2Fusion, CameraDrvPerception2FusionEvent);
//SubWrappers
GENERATE_SUB_WRAPPER(CamDrv2CamDrvPerception_Required, CamDrv2CamDrvPerception_SubDataWrapper, CameraDrivingServiceProxy, perception::Cam2CamPerceptionStruct, CamDrv2CamDrvPerceptionOneEvent, "16", 10);
GENERATE_SUB_WRAPPER(Slam2DrvPerceptionOdom_Required, Slam2DrvPerceptionOdom_SubDataWrapper, SLAMServiceProxy, dpc::slam_odometry, SLAMOdometryEvent, "8", 10);
GENERATE_SUB_WRAPPER(CAN2DrvPerception_Required, CAN2DrvPerception_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);
GENERATE_SUB_WRAPPER(VED2DrvPerception_Required, VED2DrvPerception_SubDataWrapper, VEDServiceProxy, dpc::VED4FusionEgoMotion, VED2FusionEgoMotionEvent, "11", 10);

class GeneralWrapper {
public:
    //Provides
    CamDrvPerception2Fusion_Provide _CamDrvPerception2Fusion_Provide;
    //Requireds
    CamDrv2CamDrvPerception_Required _CamDrv2CamDrvPerception_Required;
    Slam2DrvPerceptionOdom_Required _Slam2DrvPerceptionOdom_Required;
    CAN2DrvPerception_Required _CAN2DrvPerception_Required;
    VED2DrvPerception_Required _VED2DrvPerception_Required;
    
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
    void Start();
};


#endif
